
;;  SCHEME IN SCHEME (STACK-BASED IMPLEMENTATION)
;;  Copyright (C) 2008  Vilem Vychodil, <vilem.vychodil@upol.cz>
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; version 2 of the License.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

(define product
  (lambda (list)
    (if (null? list)
	1
	(* (car list)
	   (product (cdr list))))))

(define product
  (lambda (list)
    (call/cc
     (lambda (return)
       (define product
	 (lambda (list)
	   (if (null? list)
	       1
	       (if (= (car list) 0)
		   (return 0)
		   (* (car list)
		      (product (cdr list)))))))
       (product list)))))

(define generate-depth-iterator
  (lambda (l)
    (define return #f)
    (define start
      (lambda ()
	(define loop
	  (lambda (l)
	    (if (null? l)
		'neco
		(if (pair? l)
		    (begin
		      (loop (car l))
		      (loop (cdr l)))
		    (call/cc
		     (lambda (new-start)
		       (begin
			 (set! start new-start)
			 (return l))))))))
	(loop l)
	(return '())))
    (lambda ()
      (call/cc
       (lambda (f)
	 (set! return f)
	 (start))))))

(define p (generate-depth-iterator '(a (b (c (d)) e))))
(define q (generate-depth-iterator '(((a b) ((c d))) e)))
(p)
(q)
(p)
(q)
(p)
(q)
(p)
(q)
(p)
(q)
(p)
(q)
